const fs = require("fs");
const path = require("path");
const Jimp = require('jimp');
const sizeOf = require('image-size');

const pwd = ".";
const target_str = '.assets';

async function cropAndSave(x, y, width, height, i, folderPath, imagePath) {
    const image = await Jimp.read(imagePath);
    await image.crop(x, y, width, height);

    const outputFolder = path.join(pwd, folderPath);
    const outputFilename = `${i}.png`;
    const outputPath = path.join(outputFolder, outputFilename);

    await fs.promises.mkdir(outputFolder, { recursive: true });
    await image.writeAsync(outputPath);

    console.log(`图片 ${imagePath} 已切割并保存至 ${outputPath}`);
}

fs.readdir(pwd, async function (err, files) {
    if (err) {
        return console.log(err);
    }

    for (const item of files) {
        if (item.includes(target_str)) {
            const dirName = item.split(target_str)[0];
            const dirPath = path.join(pwd, dirName);
            const filesInDir = await fs.promises.readdir(dirPath);

            for (let i = 0; i < filesInDir.length; i++) {
                const element = filesInDir[i];
                const imagePath = path.join(dirPath, element);
                const dimensions = sizeOf(imagePath);
                const imgHeight = dimensions.width > 1200 ? dimensions.width / 35 : 1200 / 35;

                for (let j = 0; dimensions.height - imgHeight * j > 0; j++) {
                    const cropHeight = Math.min(imgHeight, dimensions.height - imgHeight * j);
                    await cropAndSave(0, imgHeight * j, dimensions.width, cropHeight, j, dirName, imagePath);
                }
            }
        }
    }
});
